using System;

using N14PKLibrary;
using N14PKLibrary.Data;
using N14PKLibrary.HelperClass;

class N14PKBrowseExtension
{
	public static void Function( N14PK n14pk, int id, ShiroData data )
	{
		foreach ( var k in data.Kukaku )
		{
			if ( !k.IsKakuchouzumi )
				// g̓X[
				continue;

			// ݉\tO
			var canKensetsu = false;

			switch ( k.ShisetsuID )
			{
				case -1:
					if ( k.KokudakaMax != 0 )
					{
						k.ShisetsuID = 9;	// n
						canKensetsu = true;
					}
					else if ( k.SyougyouMax != 0 )
					{
						k.ShisetsuID = 21;	// s
						canKensetsu = true;
					}
					else if ( k.HeisyaMax != 0 )
					{
						k.ShisetsuID = 33;	// H
						canKensetsu = true;
					}
					
					if ( k.ShisetsuID != -1 )
						k.h01C = 2;
						
					break;

				case 9:		// n
				case 10:	// 򐅘H
				case 13:	// 
				case 18:	// 
				case 21:	// s
				case 22:	// O֎s
				case 26:	// b
				case 31:	// 
				case 33:	// H
				case 36:	// 
				case 38:	// X
				case 41:	// _
				case 43:	// 
					canKensetsu = true;
					break;

				case 15:	// _Ys
					if ( k.ShigenID == 67 )
					{
						// Y
						canKensetsu = true;
					}
					break;

				case 29:	// Ė≮
					if ( k.ShigenID == 66 )
					{
						// 
						canKensetsu = true;
					}
					break;

				case 34:	// 
					if ( k.ShigenID == 69 )
					{
						// S
						canKensetsu = true;
					}
					break;

				case 40:	// 뉀
					if ( k.ShigenID == 73 )
					{
						// 
						canKensetsu = true;
					}
					break;
			}

			if ( canKensetsu )
			{
				k.h138_2 = 100;
			}
		}
		n14pk.Shirotable.Write( data );
	}
}
