// SortHistory.cs

using System.Collections.Generic;

using N14PKBrowse.Compare;

namespace N14PKBrowse.Sort
{
	/// <summary>\[gǗNX</summary>
	public class SortHistory
	{
		/// <summary>\[gۑ</summary>
		public static readonly int Max = 5;

		/// <summary>\[gf[^</summary>
		public class HistoryData
		{
			/// <summary>Jwb_CfNX</summary>
			public int Index { get; set; }

			/// <summary>vpeB</summary>
			public string PropertyName { get; set; }

			/// <summary>\[gI[_[</summary>
			public bool IsAsc { get; set; }

			/// <summary>r[h</summary>
			public CompMode Mode { get; set; }

			/// <summary>rpR[obN</summary>
			public CompareCallback Callback { get; set; }
		}

		/// <summary>\[gf[^Xg</summary>
		private List<HistoryData> _history;

		/// <summary>݂̏</summary>
		public int Count
		{
			get { return this._history.Count; }
		}

		/// <summary>RXgN^</summary>
		public SortHistory()
		{
			this._history = new List<HistoryData>();
		}

		/// <summary>CfNT</summary>
		public HistoryData this[int i]
		{
			get
			{
				if ( 0 <= i && i < this._history.Count )
				{
					return this._history[i];
				}
				return null;
			}
		}

		/// <summary>Ce[^</summary>
		public IEnumerator<HistoryData> GetEnumerator()
		{
			for ( var i = 0; i < this._history.Count; i++ )
				yield return this[i];
		}

		/// <summary>\[gf[^ۑ</summary>
		/// <param name="columnID">wb_JCfNX</param>
		/// <param name="propertyName">vpeB</param>
		/// <param name="order">\[gI[_[</param>
		/// <param name="callback">rpR[obN</param>
		public void Save( int index, string propertyName, bool isAsc, CompMode mode, CompareCallback callback )
		{
			if ( this._history.Count != 0 )
			{
				// \[gindexƓindex̃f[^폜
				this._history.RemoveAll( d => d.Index == index );
			}

			// 擪ɑ}
			this._history.Insert( 0, new HistoryData(){ Index = index, PropertyName = propertyName, IsAsc = isAsc, Mode = mode, Callback = callback } );
			
			while ( Max < this._history.Count )
			{
				// ۑ𒴂ĂΌÂ(Xg)폜
				this._history.RemoveAt( this._history.Count - 1 );
			}
		}
	}
}
